package  conv.convc;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	 rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Ccaf extends SepLinearOperator {
  protected Rsf      x;
  protected int      dim;
  
  Ccaf(Rsf      data,
       RsfSpace filtSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(filtSpace, oputSpace);
    this.x   = data;
    this.dim = data.getDimension();
  }
  
  protected Ccaf(Ccaf src) {
    super(src);
    this.x   = (Rsf) src.x.copy();
    this.dim = src.dim;
  }
  
  protected void apply(boolean add, Vector ff, Vector yy) {
    if (isFwd) 
      CutoffConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				       CutoffConvolution.kOutput);
    else
      CutoffConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				       CutoffConvolution.kFilter);
  }
  
  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Ccaf)) return false;
    Ccaf ccaf = (Ccaf) obj2;
    return (super.equals(ccaf) &&
	    this.dim == ccaf.dim &&
	    this.x.equals(ccaf.x));
  }
  
  public JamObject copy() { return new Ccaf(this); }
}
