package  conv.convc;

import 	 jam.vector.*;
import 	 jam.operator.*;
import 	rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class CcafFactory {
  Rsf input;
  
  /**
   * @param input  Rsf of input data
   */
  public CcafFactory(Rsf input) { this.input = input; }
  
  /**
   * This should calculate the filterSpace from the outputSpace and input data,
   * and return the resulting ccaf operator. But that is not possible for 
   * the Cutoff convolution since the output and input size are independent 
   * of the filter size. This method should be simply deleted.
   *
   * @deprecated 
   * @param outputSpace the RsfSpace of the output of the ccaf operator
   * @return the ccaf operator corresponding to the input data and output space
   */
  public Ccaf getCcafFromOutputSpace(RsfSpace outputSpace) {
    //RsfSpace inputSpace  = (RsfSpace) input.getSpace();
    //RsfSpace filterSpace =
    //  CutoffConvolution.createFilterSpace(inputSpace, outputSpace);
    //return new Ccaf(input, filterSpace, outputSpace, true);
    System.err.println("Error: filter unknown since independent of iput oput");
    return null;
  }
  
  /**
   * This calculates the outputSpace from the filterSpace and input data,
   * and returns the resulting ccaf operator.
   *
   * @param filterSpace the RsfSpace of the filter of the ccaf operator
   * @return the ccaf operator corresponding to the input data and filter space
   */
  public Ccaf getCcafFromFilterSpace(RsfSpace filterSpace) {
    RsfSpace inputSpace  = (RsfSpace) input.getSpace();
    RsfSpace outputSpace =
      CutoffConvolution.createOutputSpace(inputSpace, filterSpace);
    return new Ccaf(input, filterSpace, outputSpace, true);
  }
}
