package  conv.convc;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	 rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 *   y = F x  and x = F' y  where F is a cutoff convolution
 */
public class Ccai extends SepLinearOperator {
  protected Rsf f;
  protected int dim;
  
  Ccai(Rsf      filter,
       RsfSpace iputSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(iputSpace, oputSpace);
    this.f   = filter;
    this.dim = filter.getDimension();
  }
  
  protected Ccai(Ccai src) {
    super(src);
    this.f   	= (Rsf) src.f.copy();
    this.dim 	= src.dim;
  }
  
  protected void apply(boolean add, Vector xx, Vector yy) {
    if (isFwd) 
      CutoffConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				       CutoffConvolution.kOutput);
    else
      CutoffConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				       CutoffConvolution.kInput );
  }
  
  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Ccai)) return false;
    Ccai ccai = (Ccai) obj2;
    return (super.equals(ccai)   &&
	    this.dim == ccai.dim &&
	    this.f.equals(ccai.f));
  }
  
  public JamObject copy() { return new Ccai(this); }
}
