package  conv.convi;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	  rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 *   y = F x  and x = F' y  where F is a internal convolution
 */
public class Icai extends SepLinearOperator {
  protected Rsf f;
  protected int dim;

  Icai(Rsf      filter,
       RsfSpace iputSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(iputSpace, oputSpace);
    this.f   = filter;
    this.dim = filter.getDimension();
  }

  protected Icai(Icai src) {
    super(src);
    this.f   	= (Rsf) src.f.copy();
    this.dim 	= src.dim;
  }

  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Icai)) return false;
    Icai icai = (Icai) obj2;
    return (super.equals(icai)   &&
	    this.dim == icai.dim &&
	    this.f.equals(icai.f));
  }

  protected void apply(boolean add, Vector xx, Vector yy) {
    if (isFwd) 
      InternalConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				      InternalConvolution.kOutput);
    else
      InternalConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				      InternalConvolution.kInput );
  }

  public JamObject copy() { return new Icai(this); }
}
