package  conv.convi;

import 	 jam.vector.*;
import 	 jam.operator.*;
import 	 rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class IcaiFactory {
  Rsf filter;

  /**
   * @param filter  Rsf of filter coefficients
   */
  public IcaiFactory(Rsf filter) { this.filter = filter; }

  /**
   * This calculates the inputSpace from the outputSpace and filter data,
   * and returns the resulting icai operator.
   *
   * depreciated: method should not repeat class name. 
   * depreicated: use standard OperatorFactory methods.
   * @param outputSpace the RsfSpace of the output of the icai operator
   * @return the icai operator corresponding to filter data and output space
   */
  public Icai getIcaiFromOutputSpace(RsfSpace outputSpace) {
    RsfSpace filterSpace = (RsfSpace) filter.getSpace();
    RsfSpace inputSpace  =
      InternalConvolution.createInputSpace(filterSpace, outputSpace);
    return new Icai(filter, inputSpace, outputSpace, true);
  }

  /**
   * This calculates the outputSpace from the InputSpace and filter data,
   * and returns the resulting icai operator.
   *
   * @param InputSpace the RsfSpace of the Input of the icai operator
   * @return the icai operator corresponding to filter data and input space
   */
  public Icai getIcaiFromInputSpace(RsfSpace inputSpace) {
    RsfSpace filterSpace = (RsfSpace) filter.getSpace();
    RsfSpace outputSpace =
      InternalConvolution.createOutputSpace(inputSpace, filterSpace);
    return new Icai(filter, inputSpace, outputSpace, true);
  }
}
