package conv.convi;

import  rsf.vector.*;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class InternalConvolutionTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }

  public static int  test(String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis( 3, 1f, 0f, "time", "s" );
    ax[1] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis( 2, 1f, 0f, "", "" );
    filtAx[1] = new Axis( 2, 1f, 0f, "", "" );

    Rsf2 inRsf = (Rsf2) RsfFactory.newRsf(ax);
    inRsf.zero();
    inRsf.d[1][1] = 1f;
    Rsf2 filt  = (Rsf2) RsfFactory.newRsf(filtAx);
    filt.fill(1f);
    filt .d[1][0] = -1f;
    filt .d[0][1] = -1f;
    
    InternalConvolution myInternalConvolution =
      new InternalConvolution(InternalConvolution.kInput ,
			      (RsfSpace) inRsf.getSpace(),
			      InternalConvolution.kFilter,
			      (RsfSpace) filt .getSpace());
    Rsf  outRsf = (Rsf) myInternalConvolution.imageBinary(inRsf, filt);
    System.out.println( outRsf);

    Rsf2 ideal = (Rsf2) RsfFactory.newRsf( (RsfSpace) outRsf.getSpace());
    ideal.d[0][0] =  1;
    ideal.d[0][1] = -1;
    ideal.d[1][0] = -1;
    ideal.d[1][1] =  1;
    ideal.d[2][0] =  0;
    ideal.d[2][1] =  0;

    return (outRsf.equals(ideal) == true ? 0:1);
  }
}

/* // this is another test routine: it is large for timing
final
public class InternalConvolutionTest {
  public static void main( String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis( 50, 1f, 0f, "time", "s" );
    ax[1] = new Axis( 50, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis( 10, 1f, 0f, "", "" );
    filtAx[1] = new Axis( 10, 1f, 0f, "", "" );

    Rsf inRsf = RsfFactory.newRsf(    ax).setRandom();
    Rsf filt  = RsfFactory.newRsf(filtAx).setRandom();
    
    InternalConvolution myInternalConvolution =
      new InternalConvolution( "input" , (RsfSpace) inRsf.getSpace(),
                               "filter", (RsfSpace) filt .getSpace());
    Rsf outRsf =
      RsfFactory.newRsf( InternalConvolution.
               createOutputSpace((RsfSpace) inRsf.getSpace(),
                                 (RsfSpace) filt .getSpace()));
    myInternalConvolution.image( inRsf, filt, outRsf);
    System.out.println( "Done JAVA.");
  }
} */
