package  conv.conviF;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	 rsfF.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Icaf extends SepLinearOperator {
  protected Rsf      x;
  protected int      dim;

  Icaf(Rsf      data,
       RsfSpace filtSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(filtSpace, oputSpace);
    this.x   = data;
    this.dim = data.getDimension();
  }

  protected Icaf(Icaf src) {
    super(src);
    this.x   = (Rsf) src.x.copy();
    this.dim = src.dim;
  }

  protected void apply(boolean add, Vector ff, Vector yy) {
    if (isFwd) 
      InternalConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				      InternalConvolution.kOutput);
    else
      InternalConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				      InternalConvolution.kFilter);
  }

  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Icaf)) return false;
    Icaf icaf = (Icaf) obj2;
    return (super.equals(icaf) &&
	    this.dim == icaf.dim &&
	    this.x.equals(icaf.x));
  }

  public JamObject copy() { return new Icaf(this); }
}
