package  conv.conviF;

import 	 jam.vector.*;
import 	 jam.operator.*;
import 	rsfF.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class IcafFactory {
  Rsf input;

  /**
   * @param input  Rsf of input data
   */
  public IcafFactory(Rsf input) { this.input = input; }

  /**
   * This calculates the filterSpace from the outputSpace and input data,
   * and returns the resulting icaf operator.
   *
   * @param outputSpace the RsfSpace of the output of the icaf operator
   * @return the icaf operator corresponding to the input data and output space
   */
  public Icaf getIcafFromOutputSpace(RsfSpace outputSpace) {
    RsfSpace inputSpace  = (RsfSpace) input.getSpace();
    RsfSpace filterSpace =
      InternalConvolution.createFilterSpace(inputSpace, outputSpace);
    return new Icaf(input, filterSpace, outputSpace, true);
  }

  /**
   * This calculates the outputSpace from the filterSpace and input data,
   * and returns the resulting icaf operator.
   *
   * @param filterSpace the RsfSpace of the filter of the icaf operator
   * @return the icaf operator corresponding to the input data and filter space
   */
  public Icaf getIcafFromFilterSpace(RsfSpace filterSpace) {
    RsfSpace inputSpace  = (RsfSpace) input.getSpace();
    RsfSpace outputSpace =
      InternalConvolution.createOutputSpace(inputSpace, filterSpace);
    return new Icaf(input, filterSpace, outputSpace, true);
  }
}
