package conv.conviF;

import   rsf.vector.Axis;
import   rsfF.vector.*;
import   juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class InternalConvolutionTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }

  public static int  test(String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis( 3, 1f, 0f, "time", "s" );
    ax[1] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis( 2, 1f, 0f, "", "" );
    filtAx[1] = new Axis( 2, 1f, 0f, "", "" );

    Rsf inRsf = (Rsf) new Rsf(ax);
    inRsf.zero();
    int[] ind = {1,1};
    inRsf.d[ inRsf.i( ind)] =  1f;
    Rsf filt  = new Rsf(filtAx);
    filt.fill(1f);
    ind[0] = 1; ind[1] = 0;
    filt .d[ filt .i( ind)] = -1f;
    ind[0] = 0; ind[1] = 1;
    filt .d[ filt .i( ind)] = -1f;
    
    InternalConvolution myInternalConvolution =
      new InternalConvolution(InternalConvolution.kInput ,
			      (RsfSpace) inRsf.getSpace(),
			      InternalConvolution.kFilter,
			      (RsfSpace) filt .getSpace());
    Rsf  outRsf = (Rsf) myInternalConvolution.imageBinary(inRsf, filt);
    System.out.println( outRsf);

    Rsf ideal = new Rsf( (RsfSpace) outRsf.getSpace());
    ideal.d[0] = 1;
    ideal.d[1] = -1;
    ideal.d[2] = -1;
    ideal.d[3] = 1;
    ideal.d[4] = 0;
    ideal.d[5] = 0;

    return (outRsf.equals(ideal) == true ? 0:1);
  }
}
