package  conv.convt;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	 rsf.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class Tcaf extends SepLinearOperator {
  protected Rsf      x;
  protected int      dim;
  
  Tcaf(Rsf      data,
       RsfSpace filtSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(filtSpace, oputSpace);
    this.x   = data;
    this.dim = data.getDimension();
  }
  
  protected Tcaf(Tcaf src) {
    super(src);
    this.x   = (Rsf) src.x.copy();
    this.dim = src.dim;
  }
  
  protected void apply(boolean add, Vector ff, Vector yy) {
    if (isFwd) 
      TransientConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				       TransientConvolution.kOutput);
    else
      TransientConvolution.staticApply(add, x, (Rsf) ff, (Rsf) yy,
				       TransientConvolution.kFilter);
  }
  
  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Tcaf)) return false;
    Tcaf tcaf = (Tcaf) obj2;
    return (super.equals(tcaf) &&
	    this.dim == tcaf.dim &&
	    this.x.equals(tcaf.x));
  }
  
  public JamObject copy() { return new Tcaf(this); }
}
