package conv.convt;

import  rsf.vector.*;
import   rsf.vector.Axis;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class TransientConvolutionTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }
  
  public static int  test(String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis(3, 1f, 0f, "time", "s");
    ax[1] = new Axis(4, 2f, 0f, "distance", "m");
    
    Rsf2 inRsf = (Rsf2) RsfFactory.newRsf(ax);
    inRsf.zero();
    inRsf.setDatum(1,1,  1f);
    
    Rsf2 filt  = (Rsf2) RsfFactory.newRsf(2,2);
    filt. setDatum(0,0,  1f); filt.setDatum(0,1, -1f);    
    filt. setDatum(1,0, -1f); filt.setDatum(1,1,  1f);
    
    TransientConvolution myTransientConvolution =
      new TransientConvolution(TransientConvolution.kInput ,
			       (RsfSpace) inRsf.getSpace() ,
			       TransientConvolution.kFilter,
			       (RsfSpace) filt .getSpace());
    Rsf  outRsf = (Rsf) myTransientConvolution.imageBinary(inRsf, filt);
    System.out.println(outRsf);
    
    Rsf2 ideal = (Rsf2) RsfFactory.newRsf((RsfSpace) outRsf.getSpace());
    ideal.fill(0F);
    ideal.setDatum(1,1,  1F);
    ideal.setDatum(2,2,  1F);
    ideal.setDatum(1,2, -1F);
    ideal.setDatum(2,1, -1F);
    
    return (outRsf.equals(ideal) == true ? 0:1);
  }
}

/*
// this is another test routine: it is large for timing
final
public class TransientConvolutionTest {
  public static void main(String[] args) {
    Axis[] ax = new Axis[2];
    ax[0] = new Axis(50, 1f, 0f, "time", "s");
    ax[1] = new Axis(50, 2f, 0f, "distance", "m");
    
    Axis[] filtAx = new Axis[2];
    filtAx[0] = new Axis(10, 1f, 0f, "", "");
    filtAx[1] = new Axis(10, 1f, 0f, "", "");
    
    Rsf inRsf = RsfFactory.newRsf(    ax).setRandom();
    Rsf filt  = RsfFactory.newRsf(filtAx).setRandom();
    
    TransientConvolution myTransientConvolution =
      new TransientConvolution("input" , (RsfSpace) inRsf.getSpace(),
			       "filter", (RsfSpace) filt .getSpace());
    Rsf outRsf =
      RsfFactory.newRsf(TransientConvolution.
	                createOutputSpace((RsfSpace) inRsf.getSpace(),
					  (RsfSpace) filt .getSpace()));
    myTransientConvolution.image(inRsf, filt, outRsf);
    System.out.println("Done JAVA.");
  }
} */
