package  conv.convtF;

import 	 jam.vector.*;
import 	 jam.operator.*;
import   rsf.vector.Axis;
import 	 rsfF.vector.*;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class TcafTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }

  public static int  test(String[] args) {
    Axis[] ax = new Axis[1];
    ax[0] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[1];
    filtAx[0] = new Axis( 2, 1f, 0f, "", "" );

    Rsf inRsf = (Rsf) new Rsf(ax);
    inRsf.zero();
    inRsf.setDatum(1,  1f);

    Rsf filt  = new Rsf(filtAx);
    filt .fill(1f);
    filt .setDatum(1, -1f);
    
    Tcaf myTcaf =
      new TcafFactory(inRsf).getTcafFromFilterSpace((RsfSpace)
						    filt.getSpace());
    Rsf outRsf = (Rsf) myTcaf.image(filt);

    System.out.println( "Input :\n" +  inRsf + "\n\n\n");
    System.out.println( "Filter:\n" +   filt + "\n\n\n");
    System.out.println( "Output:\n" + outRsf + "\n\n");

    Rsf ideal = new Rsf((RsfSpace) outRsf.getSpace());
    ideal.zero();
    ideal.setDatum(1,  1f);
    ideal.setDatum(2, -1f);

    boolean passed1 = outRsf.equals(ideal);

    // 2D test

    Axis[] ax2 = new Axis[2];
    ax2[0] = new Axis( 3, 1f, 0f, "time", "s" );
    ax2[1] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx2 = new Axis[2];
    filtAx2[0] = new Axis( 2, 1f, 0f, "", "" );
    filtAx2[1] = new Axis( 2, 1f, 0f, "", "" );

    inRsf = (Rsf) new Rsf(ax2);
    inRsf.zero();
    inRsf.setDatum(1,1,  1f);

    filt  = new Rsf(filtAx2);
    filt. setDatum(0,0,  1f); filt.setDatum(0,1, -1f);    
    filt. setDatum(1,0, -1f); filt.setDatum(1,1,  1f);

    myTcaf =
      new TcafFactory(inRsf).getTcafFromFilterSpace((RsfSpace)
						    filt.getSpace());
    outRsf = (Rsf) myTcaf.image(filt);

    System.out.println( "Forward Operator (input):\n" +  inRsf + "\n\n\n");
    System.out.println( "Forward Input   (filter):\n" +   filt + "\n\n\n");
    System.out.println( "Forward Output  (output):\n" + outRsf + "\n\n");

    ideal = new Rsf((RsfSpace) outRsf.getSpace());
    ideal.fill(0F);
    ideal.setDatum(1,1,  1F);
    ideal.setDatum(2,2,  1F);
    ideal.setDatum(1,2, -1F);
    ideal.setDatum(2,1, -1F);

    boolean passed2 = outRsf.equals(ideal);

    // Test adjoint in 2D

    //Rsf origFilt = (Rsf) filt.duplicate();
    Rsf origFilt = (Rsf) filt.copy();

    filt.zero();
    filt = (Rsf) myTcaf.adjoint().image(outRsf);

    System.out.println( "Adjoint Operator (input):\n" +   inRsf + "\n\n");
    System.out.println( "Adjoint Input   (output):\n" +  outRsf + "\n\n\n");
    System.out.println( "Adjoint Output  (filter):\n" +    filt + "\n\n\n");

    boolean passed3 = filt.equals(origFilt);

    // Test in 4D

    int[] inDim = {4,4,4,4};
    inRsf = new Rsf( inDim);
    inRsf.rand();
    int[] filtDim = {2,2,2,2};
    myTcaf =
      new TcafFactory(inRsf).getTcafFromFilterSpace(new RsfSpace(filtDim));
    float diff = rsfF.util.RsfUtil.dotProductTest( myTcaf, "verbose");
    boolean passed4 = ( Math.abs( diff) < .00001);
    return ((passed1 && passed2 && passed3 && passed4) == true ? 0:1);
  }
}
