package  conv.convtF;

import    sep.operator.SepLinearOperator;
import 	  jam.vector.*;
import 	  jam.operator.*;
import    jam.JamObject;
import 	  rsfF.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 *
 *   y = F x  and x = F' y  where F is a transient convolution
 */
public class Tcai extends SepLinearOperator {
  protected Rsf f;
  protected int dim;

  Tcai(Rsf      filter,
       RsfSpace iputSpace,
       RsfSpace oputSpace,
       boolean  isFwd    )
  {
    super(iputSpace, oputSpace);
    this.f   = filter;
    this.dim = filter.getDimension();
  }

  protected Tcai(Tcai src) {
    super(src);
    this.f   	= (Rsf) src.f.copy();
    this.dim 	= src.dim;
  }

  protected void apply(boolean add, Vector xx, Vector yy) {
    if (isFwd) 
      TransientConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				       TransientConvolution.kOutput);
    else
      TransientConvolution.staticApply(add, (Rsf) xx, f, (Rsf) yy,
				       TransientConvolution.kInput );
  }

  public boolean equals(Object obj2) {
    if (this == obj2) return true;
    if (! (obj2 instanceof Tcai)) return false;
    Tcai tcai = (Tcai) obj2;
    return (super.equals(tcai)   &&
	    this.dim == tcai.dim &&
	    this.f.equals(tcai.f));
  }

  public JamObject copy() { return new Tcai(this); }
}
