package  conv.convtF;

import 	 jam.vector.*;
import 	 jam.operator.*;
import 	 rsfF.vector.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class TcaiFactory {
  Rsf filter;

  /**
   * @param filter  Rsf of filter coefficients
   */
  public TcaiFactory(Rsf filter) { this.filter = filter; }

  /**
   * This calculates the inputSpace from the outputSpace and filter data,
   * and returns the resulting tcai operator.
   *
   * @param outputSpace the RsfSpace of the output of the tcai operator
   * @return the tcai operator corresponding to filter data and output space
   */
  public Tcai getTcaiFromOutputSpace(RsfSpace outputSpace) {
    RsfSpace filterSpace = (RsfSpace) filter.getSpace();
    RsfSpace inputSpace  =
      TransientConvolution.createInputSpace(filterSpace, outputSpace);
    return new Tcai(filter, inputSpace, outputSpace, true);
  }

  /**
   * This calculates the outputSpace from the InputSpace and filter data,
   * and returns the resulting tcai operator.
   *
   * @param InputSpace the RsfSpace of the Input of the tcai operator
   * @return the tcai operator corresponding to filter data and input space
   */
  public Tcai getTcaiFromInputSpace(RsfSpace inputSpace) {
    RsfSpace filterSpace = (RsfSpace) filter.getSpace();
    RsfSpace outputSpace =
      TransientConvolution.createOutputSpace(inputSpace, filterSpace);
    return new Tcai(filter, inputSpace, outputSpace, true);
  }
}
