package  conv.convtF;

import 	 jam.vector.*;
import 	 jam.operator.*;
import   rsf.vector.Axis;
import 	 rsfF.vector.*;
import juice.util.Tester;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
final
public class TcaiTest {
  public static void main(String[] args) {
    Tester.exit(test(args));
  }

  public static int  test(String[] args) {
    Axis[] ax = new Axis[1];
    ax[0] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx = new Axis[1];
    filtAx[0] = new Axis( 2, 1f, 0f, "", "" );

    Rsf inRsf = (Rsf) new Rsf(ax);
    inRsf.zero();
    inRsf.setDatum(1,  1f);

    Rsf filt  = new Rsf(filtAx);
    filt .fill(1f);
    filt .setDatum(1, -1f);
    
    Tcai myTcai =
      new TcaiFactory(filt).getTcaiFromInputSpace((RsfSpace)
						  inRsf.getSpace());
    Rsf outRsf = (Rsf) myTcai.image(inRsf);

    System.out.println( "Input :\n" +  inRsf + "\n\n\n");
    System.out.println( "Filter:\n" +   filt + "\n\n\n");
    System.out.println( "Output:\n" + outRsf + "\n\n");

    Rsf ideal = new Rsf((RsfSpace) outRsf.getSpace());
    ideal.zero();
    ideal.setDatum(1,  1f);
    ideal.setDatum(2, -1f);

    boolean passed1 = outRsf.equals(ideal);

    // 2D test

    Axis[] ax2 = new Axis[2];
    ax2[0] = new Axis( 3, 1f, 0f, "time", "s" );
    ax2[1] = new Axis( 4, 2f, 0f, "distance", "m" );

    Axis[] filtAx2 = new Axis[2];
    filtAx2[0] = new Axis( 2, 1f, 0f, "", "" );
    filtAx2[1] = new Axis( 2, 1f, 0f, "", "" );

    inRsf = (Rsf) new Rsf(ax2);
    inRsf.zero();
    inRsf.setDatum(1,1,  1f);

    filt  = new Rsf(filtAx2);
    filt. setDatum(0,0,  1f); filt.setDatum(0,1, -1f);    
    filt. setDatum(1,0, -1f); filt.setDatum(1,1,  1f);

    myTcai =
      new TcaiFactory(filt).getTcaiFromInputSpace((RsfSpace)
						  inRsf.getSpace());
    outRsf = (Rsf) myTcai.image(inRsf);

    System.out.println( "Forward Operator (input):\n" +  inRsf + "\n\n\n");
    System.out.println( "Forward Input   (filter):\n" +   filt + "\n\n\n");
    System.out.println( "Forward Output  (output):\n" + outRsf + "\n\n");

    ideal = new Rsf((RsfSpace) outRsf.getSpace());
    ideal.fill(0F);
    ideal.setDatum(1,1,  1F);
    ideal.setDatum(2,2,  1F);
    ideal.setDatum(1,2, -1F);
    ideal.setDatum(2,1, -1F);

    boolean passed2 = outRsf.equals(ideal);

    // Test adjoint in 2D
    
    inRsf .zero();
    outRsf.zero();
    outRsf.setDatum(0,1, 1f);
    inRsf = (Rsf) myTcai.adjoint().image(outRsf);

    System.out.println( "Adjoint Input :\n" +  outRsf + "\n\n\n");
    System.out.println( "Adjoint Filter:\n" +    filt + "\n\n\n");
    System.out.println( "Adjoint Output:\n" +   inRsf + "\n\n");

    ideal = new Rsf((RsfSpace) inRsf.getSpace());
    ideal.zero();
    ideal.setDatum(0,0, -1f);
    ideal.setDatum(0,1,  1f);

    boolean passed3 = inRsf.equals(ideal);

    // Test in 4D

    int[] inDim   = {4,4,4,4};
    int[] filtDim = {2,2,2,2};
    filt  = new Rsf(filtDim);
    filt.rand();
    myTcai = new TcaiFactory(filt).getTcaiFromInputSpace(new RsfSpace(inDim));
    float diff = rsfF.util.RsfUtil.dotProductTest( myTcai, "verbose");
    boolean passed4 = ( Math.abs( diff) < .00001);

    return ((passed1 && passed2 && passed3 && passed4) == true ? 0:1);
  }
}
