package conv.deconF;

import rsfF.vector.*;
//import rsfF.operator.*;
import sep.io.*;
import jam.vector.*;
import jam.solver.*;
import jam.operator.*;
import juice.solver.*;
import juice.operator.*;
import conv.conviF.*; 

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */

/**
* I solve d = B m for m. 
* B is a convolution operator (Icai) (think of it convolving a reflectivity 
* function and an unknown wavelet m). 
* d is a given 1-D time series (think of it as a seismic trace). 
* I create the normal equations: d* = B'd and B* = B'B and 
* call a CGSolver. 
*/ 
public class Deconv { 
  public static void main(String[] args) {

    ArgumentKeeper argKeeper = new ArgumentKeeper( args);
    int   niter    = argKeeper.getInt  ( "niter"   , "15"   );

    // Get d (the trace)
    Rsf trace   = new Rsf(                         System.in  ); 

    /*
      Does it make sense to turn this into an object? Is there 
      anything we want to hide? Not right now but maybe when 
      we later need Deconvolutions in a program such as Lomo. 
      What is the right interface? A good argument for making 
      things such as Stopper a single object. 
      But maybe the solver should be an constructor argument 
      or settable. Or the Operator (rather than just the trace). 
      But what do we try to hide? 
      How about a short note on good oo programming ... 

  }
  public icaiDecon(Rsf reflectivity, Stopper Crit) { 
     setInput(Rsf trace);
     solve() returns Rsf restult;
     
  }

  */


    // Create the Icaf operator (convolve the reflectivity)
    Rsf reflect = new Rsf(argKeeper.getString( "reflectivity"));
    hasAdjoint 
      myConv = new IcafFactory(reflect).getIcafFromOutputSpace(
		 (RsfSpace) trace.getSpace()); 

    // Create the positive definite equation B'd = B'B m
    Vector b =       myConv.adjoint().image(trace);
    CompoundLinearOperatorAdjoint
      L = new CompoundLinOpAdj(myConv, myConv.adjoint());

    // Create an initial m (the wavelet) 
    Rsf    x = (Rsf) L.getDomain().newMember();
    x.zero(); //x.rand();

    // Solve
    // new CGSolver(new IteratorSmall()).solve( L, b, x );
    new    CGSolver(                   ).solve( L, b, x );

    x.write(System.out); 
    /* // compare with a known result 
       Rsf wavelet = new Rsf(argKeeper.getString("wavelet"));
       x.sub(wavelet);
       x.write("residual.H");
    */
  }
}


    

    
