package conv.deconF;

import jam.operator.*;
import rsf.vector.Axis;
import rsfF.vector.*;
import sep.io.*;
import conv.conviF.*;

/**
 * <BR><!--#include file="./source.inc"--><BR>
 */
public class SynTrace { 
  public static void main( String[] args) { 
    
    ArgumentKeeper argKeeper = new ArgumentKeeper( args);
    int   n1      = argKeeper.getInt   ( "n1",     "250"   );
    float o1      = argKeeper.getFloat ( "o1",     "0.0F"  );
    float d1      = argKeeper.getFloat ( "d1",     "0.004F");
    String label1 = argKeeper.getString( "label1", "time"  );
    String unit1  = argKeeper.getString( "unit1",  "ms"    );

    Axis[] myAxisArray = {new Axis(n1,o1,d1,label1,unit1)}; 
    Rsf reflectivity   = new Rsf (myAxisArray);
    reflectivity.rand();
    reflectivity.write("reflect1.H"); 

    Rsf wavelet = new Rsf( argKeeper.getString( "wavelet"));

    hasAdjoint 
      myConv = new IcafFactory(reflectivity).getIcafFromFilterSpace(
		 (RsfSpace) wavelet.getSpace());
    Rsf seisTrace = (Rsf) myConv.image(wavelet); 

    seisTrace.write(System.out);
  }
}

